Customize ListView as chat window in Vue ListView component

12 Mar 202518 minutes to read

ListView can be customized as a chat window. To achieve that, use the ListView template property and Avatar component.

  • The ListView template property is used to showcase the ListView as a chat window.
  • The Avatar component is used to design the image of the contact person.

Refer to the template code snippet below for the chat window template.

var demoVue = Vue.component("demo", {
    template: `<div class='settings' v-if='data.chat!="receiver"'>
      <div id='content'>
      <div class='name'></div>
            <div id='info'></div>
            </div>
            <div id='image' v-if='data.avatar!=""'><span class='e-avatar img1 e-avatar-circle'></span></div>
            <div id='image'  v-if='data.avatar==""'><span :class="[data.pic + ' img1 e-avatar e-avatar-circle']"> </span></div>
            </div>
            <div class='settings' v-else>
            <div id='image2'  v-if='data.avatar!=""'><span class='e-avatar img2 e-avatar-circle'></span></div>
            <div id='image2'  v-if='data.avatar==""'><span :class="[data.pic +' img2 e-avatar e-avatar-circle']"> </span></div>
            <div id='content1'>
            <div class='name1'></div>
            <div id='info1'></div>
            </div>
            </div>`,
    data() {
        return {
        data: {}
        };
    }
});

Chat order in template

In ListView template, we have rendered the list items based on receiver and sender information from the dataSource of the ListView.

Adding messages to chat window

  • Use a textbox to get messages from the user.
  • Add the textbox message to the ListView dataSource using the addItem method.
 btnClick: function() {
      let value = this.$refs.textbox.value;
      this.$refs.listObj.addItem([{ text: "Amenda", contact: value, id: "2", avatar: "A", pic: "", chat: "receiver" }]);
      this.$refs.textbox.value = "";
    }
<template>
  <div class="control-section">
    <!-- ListView element -->
    <ejs-listview id='List' ref='listObj' :dataSource='data' :headerTitle='headerTitle' :template='Template'
      :showHeader='true' :fields='fields' :width='width'></ejs-listview>
    <div style="width: 350px;margin: 0 auto;"><input id="name" ref="textbox" style="width: 275px" class="e-input"
        type="text" placeholder="Type your message" />
      <ejs-button id="btn" style="float:right" v-on:click="btnClick">Send</ejs-button>
    </div>
  </div>
</template>

<script setup>

import { ListViewComponent as EjsListview } from "@syncfusion/ej2-vue-lists";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";
import { createApp, ref } from "vue";

const listObj = ref(null);
const textbox = ref(null);
var demoVue = createApp().component("demo", {
  template: `<div class='settings' v-if='data.chat!="receiver"'>
     <div id='content'>
     <div class='name'></div>
           <div id='info'></div>
           </div>
           <div id='image' v-if='data.avatar!=""'><span class='e-avatar img1 e-avatar-circle'></span></div>
           <div id='image'  v-if='data.avatar==""'><span :class="[data.pic + ' img1 e-avatar e-avatar-circle']"> </span></div>
           </div>
           <div class='settings' v-else>
           <div id='image2'  v-if='data.avatar!=""'><span class='e-avatar img2 e-avatar-circle'></span></div>
           <div id='image2'  v-if='data.avatar==""'><span :class="[data.pic +' img2 e-avatar e-avatar-circle']"> </span></div>
           <div id='content1'>
           <div class='name1'></div>
           <div id='info1'></div>
           </div>
           </div>`,
  data() {
    return {
      data: {}
    };
  }
});


const data = [
  {
    text: "Jenifer",
    contact: "Hi",
    id: "1",
    avatar: "",
    pic: "pic01", chat: "sender"
  },
  { text: "Amenda", contact: "Hello", id: "2", avatar: "A", pic: "", chat: "receiver" },
  {
    text: "Jenifer",
    contact: "What Knid of application going to launch",
    id: "4",
    avatar: "",
    pic: "pic02", chat: "sender"
  },
  {
    text: "Amenda ",
    contact: "A knid of Emergency broadcast App",
    id: "5",
    avatar: "A",
    pic: "", chat: "receiver"
  },
  {
    text: "Jacob",
    contact: "Can you please elaborate",
    id: "6",
    avatar: "",
    pic: "pic04", chat: "sender"
  },
];
const fields = { text: "Name" };
const width = '350px';
const headerTitle = 'Chat';
const Template = () => {
  return {
    template: demoVue,
  };
}

const btnClick = () => {
  let value = textbox.value.value;
  listObj.value.addItem([{ text: "Amenda", contact: value, id: "2", avatar: "A", pic: "", chat: "receiver" }]);
  textbox.value.value = "";
}

</script>

<style>
#List {
  margin: 0 auto;
  border: 1px solid #ccc;
}

#List .e-list-item {
  height: auto;
  cursor: pointer;
}

#List .e-list-header .e-text {
  font-family: sans-serif;
  font-size: 18px;
  line-height: 26px;
}

#List #info,
#List .name {
  font-size: 11px;
  line-height: 20px;
}

#List .name {
  padding-top: 3px;
  font-weight: 500;
  padding-left: 150px;
}

#List #info {
  float: right;
  margin-right: 10px;
}

.pic01 {
  background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/1.png");
}

.pic02 {
  background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/3.png");
}

.pic03 {
  background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/5.png");
}

.pic04 {
  background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/2.png");
}

.img2.e-avatar {
  margin-left: 10px;
  margin-top: 7px !important;
  font-size: 13px;
}

#List #content1 {
  width: 200px;
  background-color: aliceblue;
  display: inline-block;
  margin: 5px;

}

#List #info1,
#List .name1 {
  font-size: 11px;
  line-height: 20px;
  margin-left: 10px;
}

#List .name1 {
  padding-top: 3px;
  font-weight: 500;
}

#List #content {
  margin: 5px;
  width: 200px;
  margin-left: 90px;
  background-color: aliceblue;
  display: inline-block
}

#image {
  float: right;
  display: inline-block;

}

#image2 {
  float: left;
  display: inline-block;

}

.img1.e-avatar {
  margin-right: 10px;
  margin: 5px;
  font-size: 13px;
}

.e-listview .e-list-item {
  padding: 0px !important;
}

.e-listview .e-list-header {
  color: white !important;
}

.e-listview .e-list-header {
  background: rgb(2, 120, 215) !important;
}

#List.e-listview .e-list-item.e-hover {
  background-color: transparent;
}
</style>
<template>
  <div class="control-section">
   <!-- ListView element -->
   <ejs-listview id='List' ref='listObj' :dataSource='data' :headerTitle='headerTitle' :template='Template' :showHeader='true' :fields='fields' :width='width'></ejs-listview>
 <div style="width: 350px;margin: 0 auto;"><input id="name" ref="textbox" style="width: 275px" class="e-input" type="text" placeholder="Type your message"/>
   <ejs-button id="btn" style="float:right" v-on:click.native="btnClick">Send</ejs-button></div>
 </div>
</template>

<script>

import { ListViewComponent } from "@syncfusion/ej2-vue-lists";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
import { createApp } from "vue";

var demoVue = createApp().component("demo", {
   template: `<div class='settings' v-if='data.chat!="receiver"'>
     <div id='content'>
     <div class='name'></div>
           <div id='info'></div>
           </div>
           <div id='image' v-if='data.avatar!=""'><span class='e-avatar img1 e-avatar-circle'></span></div>
           <div id='image'  v-if='data.avatar==""'><span :class="[data.pic + ' img1 e-avatar e-avatar-circle']"> </span></div>
           </div>
           <div class='settings' v-else>
           <div id='image2'  v-if='data.avatar!=""'><span class='e-avatar img2 e-avatar-circle'></span></div>
           <div id='image2'  v-if='data.avatar==""'><span :class="[data.pic +' img2 e-avatar e-avatar-circle']"> </span></div>
           <div id='content1'>
           <div class='name1'></div>
           <div id='info1'></div>
           </div>
           </div>`,
   data() {
       return {
       data: {}
       };
   }
});

export default {
name: "App",
components: {
"ejs-listview":ListViewComponent,
"ejs-button":ButtonComponent
},
 data: function() {
   return {
    data:  [
       {
         text: "Jenifer",
         contact: "Hi",
         id: "1",
         avatar: "",
         pic: "pic01", chat: "sender"
       },
       { text: "Amenda", contact: "Hello", id: "2", avatar: "A", pic: "", chat: "receiver" },
       {
         text: "Jenifer",
         contact: "What Knid of application going to launch",
         id: "4",
         avatar: "",
         pic: "pic02",chat: "sender"
       },
       {
         text: "Amenda ",
         contact: "A knid of Emergency broadcast App",
         id: "5",
         avatar: "A",
         pic: "", chat: "receiver"
       },
       {
         text: "Jacob",
         contact: "Can you please elaborate",
         id: "6",
         avatar: "",
         pic: "pic04",chat: "sender"
       },
     ],
     fields: { text: "Name" },
     width:'350px',
     headerTitle: 'Chat',
        Template: function() {
           return {
               template: demoVue,
           };
       }
   };
 },
 methods: {
   btnClick: function() {
     let value = this.$refs.textbox.value;
     this.$refs.listObj.addItem([{ text: "Amenda", contact: value, id: "2", avatar: "A", pic: "", chat: "receiver" }]);
     this.$refs.textbox.value = "";
   }
 }
}
</script>
<style>

#List {
 margin: 0 auto;
 border: 1px solid #ccc;
}

#List .e-list-item {
 height: auto;
 cursor: pointer;
}

#List .e-list-header .e-text {
 font-family: sans-serif;
 font-size: 18px;
 line-height: 26px;
}

#List #info,
#List .name {
 font-size: 11px;
 line-height: 20px;
}

#List .name {
 padding-top: 3px;
 font-weight: 500;
  padding-left:150px;
}
#List #info {
 float: right;
 margin-right:10px;
}
.pic01 {
 background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/1.png");
}

.pic02 {
 background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/3.png");
}

.pic03 {
 background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/5.png");
}

.pic04 {
 background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/2.png");
}

.img2.e-avatar {
 margin-left: 10px;
 margin-top: 7px !important;
 font-size: 13px;
}

#List #content1 {
 width: 200px;
 background-color: aliceblue;
 display: inline-block;
 margin: 5px;
 
}

#List #info1,
#List .name1 {
 font-size: 11px;
 line-height: 20px;
 margin-left: 10px;
}

#List .name1 {
 padding-top: 3px;
 font-weight: 500;
}
#List #content {
   margin: 5px;
   width: 200px;
   margin-left: 90px;
   background-color: aliceblue;
   display:inline-block
}
#image {
   float: right;
   display: inline-block;

}
#image2 {
   float: left;
   display: inline-block;

}
.img1.e-avatar {
   margin-right: 10px;
   margin: 5px;
   font-size: 13px;
}
.e-listview .e-list-item {
 padding: 0px !important;
}
.e-listview .e-list-header{
 color: white !important;
}
.e-listview .e-list-header{
 background: rgb(2, 120, 215) !important;
}
#List.e-listview .e-list-item.e-hover {
 background-color: transparent;
}
</style>

Customize ListView as chat window in React ListView component

23 Jan 202524 minutes to read

The ListView can be customizable as a chat window. To achieve this, use ListView template property and Avatar component.

  • The ListView template property is used to showcase the ListView as a chat window.
  • The Avatar component is used to design the image of the contact person.

Refer the below template code snippet for Template of chat window.

function listTemplate(data: any): JSX.Element {
        let sendertemplate = <div className='settings'><div id="content"><div className="name">{data.text}</div><div id="info">{data.contact}</div></div>{
                    data.avatar !== "" ?
                        <div id="image"><span className='e-avatar img1 e-avatar-circle'>{data.avatar}</span></div> : <div id="image"><span className={`${data.pic} img1 e-avatar e-avatar-circle`}></span></div>
                }</div>
        let receivertemplate = <div className='settings'>{
                    data.avatar !== "" ?
                        <div id="image2"><span className='e-avatar img2 e-avatar-circle'>{data.avatar}</span></div> : <div id="image2"><span className={`${data.pic} img2 e-avatar e-avatar-circle`}></span></div>
                }<div id="content1"><div className="name1">{data.text}</div><div id="info1">{data.contact}</div></div></div>


        return (
            <div>
                {data.chat !== "receiver" ? (sendertemplate) : (receivertemplate)}
            </div>
        );
    }
function listTemplate(data) {
    let sendertemplate = <div className='settings'><div id="content"><div className="name">{data.text}</div><div id="info">{data.contact}</div></div>{data.avatar !== "" ?
            <div id="image"><span className='e-avatar img1 e-avatar-circle'>{data.avatar}</span></div> : <div id="image"><span className={`${data.pic} img1 e-avatar e-avatar-circle`}></span></div>}</div>;
    let receivertemplate = <div className='settings'>{data.avatar !== "" ?
            <div id="image2"><span className='e-avatar img2 e-avatar-circle'>{data.avatar}</span></div> : <div id="image2"><span className={`${data.pic} img2 e-avatar e-avatar-circle`}></span></div>}<div id="content1"><div className="name1">{data.text}</div><div id="info1">{data.contact}</div></div></div>;
    return (<div>
                {data.chat !== "receiver" ? (sendertemplate) : (receivertemplate)}
            </div>);
}

Chat order in template

In the ListView template, we have rendered the list items based on receiver and sender information from dataSource of the ListView.

Adding messages to chat window

* Use textbox to get message from user.
* Add the textbox message to the ListView dataSource using [addItem](https://ej2.syncfusion.com/react/documentation/api/list-view/#additem) method.
function btnClick() {
    let value = textboxEle.value;
    listObj.addItem([{ text: "Amenda", contact: value, id: "2", avatar: "A", pic: "", chat: "receiver" }]);
    textboxEle.value ="";
}
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
function App() {
  let listObj = null;
  let textboxEle;
  //Define an array of JSON data
  let data = [
    {
      text: "Jenifer",
      contact: "Hi",
      id: "1",
      avatar: "",
      pic: "pic01",
      chat: "sender"
    },
    { text: "Amenda", contact: "Hello", id: "2", avatar: "A", pic: "", chat: "receiver" },
    {
      text: "Jenifer",
      contact: "What Knid of application going to launch",
      id: "4",
      avatar: "",
      pic: "pic01",
      chat: "sender"
    },
    {
      text: "Amenda ",
      contact: "A knid of Emergency broadcast App",
      id: "5",
      avatar: "A",
      pic: "",
      chat: "receiver"
    },
    {
      text: "Jacob",
      contact: "Can you please elaborate",
      id: "6",
      avatar: "",
      pic: "pic04",
      chat: "sender"
    }
  ];
  function listTemplate(data) {
    const sendertemplate = (<div className="settings">
      <div id="content">
        <div className="name">{data.text}</div>
        <div id="info">{data.contact}</div>
      </div>
      {data.avatar !== "" ? (<div id="image">
        <span className="e-avatar img1 e-avatar-circle">{data.avatar}</span>
      </div>) : (<div id="image">
        <span className={`${data.pic} img1 e-avatar e-avatar-circle`} />
      </div>)}
    </div>);
    const receivertemplate = (<div className="settings">
      {data.avatar !== "" ? (<div id="image2">
        <span className="e-avatar img2 e-avatar-circle">{data.avatar}</span>
      </div>) : (<div id="image2">
        <span className={`${data.pic} img2 e-avatar e-avatar-circle`} />
      </div>)}
      <div id="content1">
        <div className="name1">{data.text}</div>
        <div id="info1">{data.contact}</div>
      </div>
    </div>);
    return <div>{data.chat !== "receiver" ? sendertemplate : receivertemplate}</div>;
  }
  function btnClick() {
    const value = textboxEle.value;
    listObj.addItem([
      { text: "Amenda", contact: value, id: "2", avatar: "A", pic: "", chat: "receiver" }
    ]);
    textboxEle.value = "";
  }
  return (<div>
    {/* ListView element */}
    <ListViewComponent id="List" dataSource={data} headerTitle="Chat" showHeader={true} template={listTemplate} ref={scope => {
      listObj = scope;
    }} />

    <input id="inputname" className="e-input" ref={textbox => {
      textboxEle = textbox;
    }} type="text" placeholder="Type your message" />

    <ButtonComponent id="btn" onClick={btnClick.bind(this)}>
      Send
    </ButtonComponent>
  </div>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

function App() {
  let listObj: ListViewComponent = null as any;
  let textboxEle: any;
  //Define an array of JSON data
  let data: { [key: string]: Object }[] = [
    {
      text: "Jenifer",
      contact: "Hi",
      id: "1",
      avatar: "",
      pic: "pic01",
      chat: "sender"
    },
    { text: "Amenda", contact: "Hello", id: "2", avatar: "A", pic: "", chat: "receiver" },
    {
      text: "Jenifer",
      contact: "What Knid of application going to launch",
      id: "4",
      avatar: "",
      pic: "pic01",
      chat: "sender"
    },
    {
      text: "Amenda ",
      contact: "A knid of Emergency broadcast App",
      id: "5",
      avatar: "A",
      pic: "",
      chat: "receiver"
    },
    {
      text: "Jacob",
      contact: "Can you please elaborate",
      id: "6",
      avatar: "",
      pic: "pic04",
      chat: "sender"
    }
  ];

  function listTemplate(data: any): JSX.Element {
    const sendertemplate = (
      <div className="settings">
        <div id="content">
          <div className="name">{data.text}</div>
          <div id="info">{data.contact}</div>
        </div>
        {data.avatar !== "" ? (
          <div id="image">
            <span className="e-avatar img1 e-avatar-circle">{data.avatar}</span>
          </div>
        ) : (
          <div id="image">
            <span className={`${data.pic} img1 e-avatar e-avatar-circle`} />
          </div>
        )}
      </div>
    );

    const receivertemplate = (
      <div className="settings">
        {data.avatar !== "" ? (
          <div id="image2">
            <span className="e-avatar img2 e-avatar-circle">{data.avatar}</span>
          </div>
        ) : (
          <div id="image2">
            <span className={`${data.pic} img2 e-avatar e-avatar-circle`} />
          </div>
        )}
        <div id="content1">
          <div className="name1">{data.text}</div>
          <div id="info1">{data.contact}</div>
        </div>
      </div>
    );

    return <div>{data.chat !== "receiver" ? sendertemplate : receivertemplate}</div>;
  }

  function btnClick() {
    const value = textboxEle.value;
    listObj.addItem([
      { text: "Amenda", contact: value, id: "2", avatar: "A", pic: "", chat: "receiver" }
    ]);
    textboxEle.value = "";
  }

  return (
    <div>
      {/* ListView element */}
      <ListViewComponent
        id="List"
        dataSource={data}
        headerTitle="Chat"
        showHeader={true}
        template={listTemplate as any}
        ref={scope => {
          listObj = scope as any;
        }}
      />

      <input
        id="inputname"
        className="e-input"
        ref={textbox => {
          textboxEle = textbox;
        }}
        type="text"
        placeholder="Type your message"
      />

      <ButtonComponent id="btn" onClick={btnClick.bind(this)}>
        Send
      </ButtonComponent>
    </div>
  );
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
#List {
  margin: 0 auto;
  border: 1px solid #ccc;
}

#List .e-list-item {
  height: auto;
  cursor: pointer;
}

#List .e-list-header .e-text {
  font-family: sans-serif;
  font-size: 18px;
  line-height: 26px;
}

#List #info,
#List .name {
  font-size: 11px;
  line-height: 20px;
}

#List .name {
  padding-top: 3px;
  font-weight: 500;
  padding-left: 150px;
  margin-left: 55px;
}

#List #info {
  float: right;
  margin-right: 10px;
}

.pic01 {
  background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/1.png");
}

.pic02 {
  background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/3.png");
}

.pic03 {
  background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/5.png");
}

.pic04 {
  background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/2.png");
}

.img2 {
  margin-left: 10px;
  margin-top: 7px;
  font-size: 13px;
}

#List #content1 {
  width: 200px;
  background-color: aliceblue;
  display: inline-block;
  margin: 5px;

}

#List #info1,
#List .name1 {
  font-size: 11px;
  line-height: 20px;
  margin-left: 10px;
}

#List .name1 {
  padding-top: 3px;
  font-weight: 500;
}

#List #content {
  margin: 5px;
  width: 250px;
  margin-left: 62px;
  background-color: aliceblue;
  display: inline-block
}

#image {
  float: right;

}

#image2 {
  float: left;

}

.img1 {
  margin-right: 10px;
  margin: 5px;
  font-size: 13px;
}

.e-listview .e-list-header {
  color: white;
}

.e-listview .e-list-header {
  background: rgb(2, 120, 215);
}

#List.e-listview .e-hover {
  background-color: transparent;
}

#inputname {
  width: 275px
}

.message {
  width: 350px;
  margin: 0 auto;
}

#btn {
  float: right
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React ListView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-buttons/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-react-lists/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-layouts/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-inputs/styles/material.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='element' style="margin:0 auto; max-width:400px;">
        <div id='loader'>Loading....</div>
    </div>
    <style>
        #List {
            margin: 0 auto;
            border: 1px solid #ccc;
        }

        #List .e-list-item {
            height: auto;
            cursor: pointer;
        }

        #List .e-list-header .e-text {
            font-family: sans-serif;
            font-size: 18px;
            line-height: 26px;
        }

        #List #info1,
        #List .name1 {
            margin-left: 10px;
        }

        #List #info,
        #List .name,
        #List #info1,
        #List .name1 {
            font-size: 11px;
            line-height: 20px;
        }

        #List .name {
            padding-left: 150px;
            margin-left: 55px;
        }

        #List #info {
            float: right;
            margin-right: 10px;
        }

        .pic01 {
            background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/1.png");
        }

        .pic02 {
            background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/3.png");
        }

        .pic03 {
            background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/5.png");
        }

        .pic04 {
            background-image: url("https://ej2.syncfusion.com/demos/src/grid/images/2.png");
        }

        .img2 {
            margin-left: 10px;
            margin-top: 7px;
            font-size: 13px;
        }

        #List #content1 {
            width: 200px;
            background-color: aliceblue;
            display: inline-block;
            margin: 5px;
        }

        #List .name1,
        #List .name {
            padding-top: 3px;
            font-weight: 500;
        }

        #List #content {
            margin: 5px;
            width: 250px;
            margin-left: 62px;
            background-color: aliceblue;
            display: inline-block
        }

        #image {
            float: right;
            /* display: inline-block; */
        }

        #image2 {
            float: left;
            /* display: inline-block; */
        }

        .img1 {
            margin-right: 10px;
            margin: 5px;
            font-size: 13px;
        }

        .e-listview .e-list-header {
            color: white;
            background: rgb(2, 120, 215);
        }

        #List.e-listview .e-hover {
            background-color: transparent;
        }

        #inputname {
            width: 275px
        }

        .message {
            width: 350px;
            margin: 0 auto;
        }

        #btn {
            float: right
        }
    </style>
</body>

</html>

Customize ListView as chat window in Angular ListView component

10 Sep 202513 minutes to read

ListView can be customized as a chat window interface. To achieve this functionality, use the ListView template property and Avatar component.

* The ListView template property showcases the ListView as a chat window interface.
* The Avatar component designs the profile image of each contact person.

Refer to the template code snippet below for the chat window template implementation.

    <ng-template #template let-data="">
        <div class="settings" *ngIf="data.chat!='receiver' then senderTemplate else receiverTemplate "></div>
        <ng-template #senderTemplate>
            <div id="content">
                <div class="name"></div>
                <div id="info"></div>
            </div>
            <div id="image" *ngIf="data.avatar!=''"><span class="e-avatar img1 e-avatar-circle"></span></div>
            <div id="image" *ngIf="data.avatar==''"><span class=" img1 e-avatar e-avatar-circle"> </span></div>
        </ng-template>

        <ng-template #receiverTemplate>
            <div id="image2" *ngIf="data.avatar!=''"><span class="e-avatar img2 e-avatar-circle"></span></div>
            <div id="image2" *ngIf="data.avatar==''"><span class=" img2 e-avatar e-avatar-circle"> </span></div>
            <div id="content1">
                <div class="name1"></div>
                <div id="info1"></div>
            </div>
        </ng-template>
    </ng-template>

Chat order in template

The ListView template renders list items with different layouts based on the chat property value from the data source. When chat equals “receiver”, the receiverTemplate displays the avatar on the left with message content on the right. For sender messages, the senderTemplate positions the avatar on the right with message content on the left, creating a typical chat conversation flow.

Adding messages to chat window

* Use a textbox to capture message input from the user.
* Add the textbox message to the ListView dataSource using the addItem method.
public btnClick() {
    let value = this.textboxEle.nativeElement.value;
    this.listObj.addItem([{ text: "Amenda", contact: value, id: "2", avatar: "A", pic: "", chat: "receiver" }]);
    this.textboxEle.nativeElement.value = "";
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { ListViewModule } from '@syncfusion/ej2-angular-lists';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { CommonModule } from '@angular/common';
import { Component, ViewChild } from '@angular/core';

@Component({
  imports: [ListViewModule, ButtonModule, CommonModule],
  standalone: true,
  selector: 'my-app',
  template: `
    <ejs-listview id='List' #list [dataSource]='data' headerTitle="Chat" showHeader="true" width="350px" [fields]='fields' height="200px">
  <ng-template #template let-data="">
    <div
      class="settings"
      *ngIf="
        data.chat != 'receiver';
        then senderTemplate;
        else receiverTemplate
      "
    ></div>
    <ng-template #senderTemplate>
      <div id="content">
        <div class="name"></div>
        <div id="info"></div>
      </div>
      <div id="image" *ngIf="data.avatar != ''">
        <span class="e-avatar img1 e-avatar-circle"></span>
      </div>
      <div id="image" *ngIf="data.avatar == ''">
        <span class=" img1 e-avatar e-avatar-circle"> </span>
      </div>
    </ng-template>
    <ng-template #receiverTemplate>
      <div id="image2" *ngIf="data.avatar != ''">
        <span class="e-avatar img2 e-avatar-circle"></span>
      </div>
      <div id="image2" *ngIf="data.avatar == ''">
        <span class=" img2 e-avatar e-avatar-circle"> </span>
      </div>
      <div id="content1">
        <div class="name1"></div>
        <div id="info1"></div>
      </div>
    </ng-template>
  </ng-template>
    </ejs-listview>
    <div style="width: 350px;margin: 0 auto;">
  <input
    #textbox
    id="name"
    style="width: 275px"
    class="e-input"
    type="text"
    placeholder="Type your message"
  />
  <button ejs-button id="btn" style="float:right" (click)="btnClick()">
    Send
  </button>
</div>
        `,
})
export class AppComponent {
  @ViewChild('list') listObj: any;
  @ViewChild('textbox') textboxEle: any;
  public data: Object[] = [
    {
      text: 'Jenifer',
      contact: 'Hi',
      id: '1',
      avatar: '',
      pic: 'pic01',
      chat: 'sender',
    },
    {
      text: 'Amenda',
      contact: 'Hello',
      id: '2',
      avatar: 'A',
      pic: '',
      chat: 'receiver',
    },
    {
      text: 'Jenifer',
      contact: 'What Knid of application going to launch',
      id: '4',
      avatar: '',
      pic: 'pic02',
      chat: 'sender',
    },
    {
      text: 'Amenda ',
      contact: 'A knid of Emergency broadcast App',
      id: '5',
      avatar: 'A',
      pic: '',
      chat: 'receiver',
    },
    {
      text: 'Jacob',
      contact: 'Can you please elaborate',
      id: '6',
      avatar: '',
      pic: 'pic04',
      chat: 'sender',
    },
  ];
  public fields = { text: 'Name' };
  public count = 1;
  public btnClick() {
    let value = this.textboxEle.nativeElement.value;
    this.listObj.addItem([
      {
        text: 'Amenda' + this.count.toString(),
        contact: value,
        id: (Math.random() * 1000).toFixed(0).toString(),
        avatar: 'A',
        pic: '',
        chat: 'receiver',
      },
    ]);
    this.listObj.dataBind();
    this.textboxEle.nativeElement.value = '';
    this.count++;
  }
}
@import 'node_modules/@syncfusion/ej2-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-lists/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-buttons/styles/material.css';
@import 'node_modules/@syncfusion/ej2-layouts/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-layouts/styles/material.css';
@import 'node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-inputs/styles/material.css';

#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    width: 30%;
    position: absolute;
    font-family: 'Helvetica Neue', 'calibiri';
    font-size: 14px;
    top: 45%;
    left: 45%;
}

#List {
    margin: 0 auto;
    border: 1px solid #ccc;
}

#List .e-list-item {
    height: auto;
    cursor: pointer;
}

#List .e-list-header .e-text {
    font-family: sans-serif;
    font-size: 18px;
    line-height: 26px;
}

#List #info,
#List .name {
    font-size: 11px;
    line-height: 20px;
}

#List .name {
    padding-top: 3px;
    font-weight: 500;
    padding-left: 150px;
}

#List #info {
    float: right;
    margin-right: 10px;
}

.pic01 {
    background-image: url('https://ej2.syncfusion.com/demos/src/grid/images/1.png');
}

.pic02 {
    background-image: url('https://ej2.syncfusion.com/demos/src/grid/images/3.png');
}

.pic03 {
    background-image: url('https://ej2.syncfusion.com/demos/src/grid/images/5.png');
}

.pic04 {
    background-image: url('https://ej2.syncfusion.com/demos/src/grid/images/2.png');
}

/* csslint ignore:start */
.img2 {
    margin-left: 10px;
    margin-top: 2px !important;
    font-size: 13px;
}

#List #content1 {
    width: 200px;
    background-color: aliceblue;
    display: inline-block;
    margin: 5px;
}

#List #info1,
#List .name1 {
    font-size: 11px;
    line-height: 20px;
    margin-left: 10px;
}

#List .name1 {
    padding-top: 3px;
    font-weight: 500;
}

#List #content {
    margin: 5px;
    width: 200px;
    margin-left: 75px;
    background-color: aliceblue;
    display: inline-block;
}

#image {
    float: right;
}

#image2 {
    float: left;
}

.img1 {
    margin-right: 10px;
    margin: 5px;
    font-size: 13px;
}

.e-listview .e-list-item {
    padding: 0 !important;
}

.e-listview .e-list-header {
    color: white !important;
}

.e-listview .e-list-header {
    background: rgb(2, 120, 215) !important;
}

#List.e-listview .e-hover {
    background-color: transparent;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));